; ------------------
;    Zetris v.1.12
; ------------------

; By: Cory R. Crooks

; Build Date: 11/29/97

; Started: 9/10/97

#include "TI82.H"
#include "oldcall.h"
#include "graph.h"

.org START_ADDR
.DB "Zetris v1.12",0

; Defining All Variables
; ---------------------------------------------------------

centerx = TEXT_MEM     ; Defining current block vars
centery = TEXT_MEM + 1
b1x = TEXT_MEM + 2
b1y = TEXT_MEM + 3
b2x = TEXT_MEM + 4
b2y = TEXT_MEM + 5
b3x = TEXT_MEM + 6
b3y = TEXT_MEM + 7

newcenterx = TEXT_MEM + 8 ; Defining new block vars
newcentery = TEXT_MEM + 9
newb1x = TEXT_MEM + 10
newb1y = TEXT_MEM + 11
newb2x = TEXT_MEM + 12
newb2y = TEXT_MEM + 13
newb3x = TEXT_MEM + 14
newb3y = TEXT_MEM + 15

lastaction = TEXT_MEM + 16   ; 3 equals hit down key
downcounter = TEXT_MEM + 17
linearray = TEXT_MEM + 19    ; an array of 18 bytes, storing how many blocks have
                             ; been set down per line

lastposition = TEXT_MEM + 41
thelines = TEXT_MEM + 43
nextblock = TEXT_MEM + 45
currentblock = TEXT_MEM + 46
atempvar = TEXT_MEM + 47
thescore = TEXT_MEM + 49
linesremoved = TEXT_MEM + 52
topline = TEXT_MEM + 37
blastdownflag = TEXT_MEM + 54
waitcounter = TEXT_MEM + 56
fliprequests = TEXT_MEM + 58
overrequests = TEXT_MEM + 60
lastkey = TEXT_MEM + 62
curkey = TEXT_MEM + 63

;----------------------------------------------------------


initgame:
        ld A,$8C            ;So put_pixel works good
        out (2),a
        ld a, ($8009)       ; apd timer, nice seed....
		sra a
        sra a
        sra a
        sra a
		sra a
        ld (nextblock),a
		
phattyintro:
        ROM_CALL(CLEARLCD)
        ld c,57
		ld hl, zetris_xpos_array
		jr lineloop
nextlineinintro:
        dec c
		dec c
		dec c
		inc hl
lineloop:		
		ld a,(hl)
		cp 0
		jr z, nextlineinintro
		cp 1
		jr z, outofphatty	
		ld b,a
		call drawablock
		inc hl
		jr lineloop
outofphatty:

        ld de,$2812
        ld ($8215),de
        ld hl, highscoretext
    	ROM_CALL(D_ZM_STR)  
 
        ld hl, $2838
		ld (atempvar), hl
	    ld hl, (highscore)
        call D_ZM_M_STR

		ld de,$3208
		ld ($8215),de
		ld hl, enterspeed
		ROM_CALL(D_ZM_STR)
		
		ld de,$391D
		ld ($8215),de
		ld hl, onetonine
		ROM_CALL(D_ZM_STR)
		
		ld de, $1F0B
		ld ($8215),de
		ld hl, email
		ROM_CALL(D_ZM_STR)
		
		ld de, $1815
		ld ($8215),de
		ld hl, by
		ROM_CALL(D_ZM_STR)
		
		ld de, $1820
		ld ($8215),de
		ld hl, cory
		ROM_CALL(D_ZM_STR)
		
		ld de, $1831
		ld ($8215),de
		ld hl, crooks
		ROM_CALL(D_ZM_STR)
				
        ROM_CALL(KEY_HAND)
        sub 143		
        ld e,a
		ld d,0
		ld hl,speedlookup
		add hl,de
		ld a, (hl)
		ld (waitcounter),a

showgamescreen:

        ROM_CALL(CLEARLCD)
		
		ld hl, gamescreentextarray-1
    	ld b,10
putupmoretext:
	    inc hl
		ld e,(hl)
		inc hl
		ld d,(hl)
		ld ($8215),de
		inc hl
		ld e,(hl)
		inc hl		
		ld d,(hl)
		push hl
        ex de,hl
		ROM_CALL(D_ZM_STR)
        pop hl
        djnz putupmoretext

		ld b,29
fillhorizline:
        ld c,60
		call drawafilledblock
		ld c,3
		call drawafilledblock
		inc b
		ld a,b
		cp 63
		jr nz,fillhorizline
       
	    ld c,60
fillvertline:
        ld b,29
        call drawafilledblock
		ld b,62
        call drawafilledblock
		dec c
		ld a,c
		cp 3
		jr nz, fillvertline
		
grabablock:
   
	ld a, (topline)
    cp 0
    jp nz, endgame 

    ld a, 0
    ld (linesremoved),a
    ld (blastdownflag),a
    ld a, (nextblock)
    ld (currentblock), a

    ld b,a                ; A freaky random routine....
	ld a,r
	sra a
	sra a
	srl b
	sub b
	and %00000111

	ld (nextblock), a
    ld a, 1
    ld (atempvar), a
    ld a, (nextblock)

    jr checktheblocks

comeonback:

    ld a, 0
    ld (atempvar), a
    ld a, (currentblock)

checktheblocks:

    sla a                       ; mult by 2 to get word index
	cp 12
	jr c, gobacktoload
	ld a,12
gobacktoload:
	ld hl,loadblocklookuptable
	ld e,a
	ld d,0
	add hl,de
	ld e,(hl)
	inc hl
	ld d,(hl)
	ld h,d
	ld l,e
	jr loadupcoords

loadupcoords:

    ld a, 8
	ld bc, centerx
	ld de, newcenterx
loaduploop:    
    push af	
	ld a,(hl)
	ld (bc),a
	ld (de),a
    inc bc
	inc de
	inc hl
    pop af
	dec a
    jr nz, loaduploop
	
    ld a, (atempvar)
    cp 0
    jp z, makenewcoords
  
    ld hl, centerx     ; subbing next block coords to put it at left bottom of screen
    ld b,4
asubloop:
    ld a, (hl)
	sub 33
	ld (hl),a
	inc hl
	inc hl
	djnz asubloop
	
    ld hl, centery
    ld b,4
asubloop2:
    ld a, (hl)
	sub 40
	ld (hl),a
	inc hl
	inc hl
	djnz asubloop2

    ld b, 11
    ld c, 17

loopbackforerasingnextblock:      ; erase a 4 x 4 block (i think..) where next block was...

    call eraseafilledblock
    ld b, 14
    call eraseafilledblock
    ld a, c
    sub 3
    ld c,a
    ld b,11 
    cp 5
    jr nz,loopbackforerasingnextblock
     
    call drawblock

    jp comeonback

keydloop:

        ld bc,(downcounter)     ; used to make block go down every now and again
        inc bc                
        ld a,(waitcounter)
		ld d,a
		ld a,c
        cp d                ; if some loops make it go down (the wait thing...)
        jp z, putblockdown
        ld (downcounter),bc
        
        ld a, 0            ; reset lastaction flag
        ld (lastaction),a

        ld a, (curkey)
		ld (lastkey),a
		ld a,($8001)
		ld (curkey),a
		cp 0
		jr nz, dawaitloop
        ld hl, 0
		ld (overrequests),hl
		
dawaitloop:
        ld de,2750
        ld hl,$0000
loopforwait:
        inc hl
		call CP_HL_DE
		jr nz, loopforwait
				
		cp 36h
        jr Z,flipblock
        cp 17h
        jp Z,blastdown
        cp 1
		jp z,putblockdown
		cp 2
        jp Z,goleft
        cp 3
        jp Z,goright
        cp 0Fh
        jr z, endgame        ; Clear quits

        jr keydloop

endgame:
       
       call checkforhighscore

       ret

blastdown:

       ld a, 1
	   ld (blastdownflag), a
	   jp putblockdown
	   
flipblock:

        ld a,(lastkey)
		cp 0
		jr nz, keydloop
		
		ld a,(centerx)
		ld (newcenterx),a
		ld d,a
		ld a,(centery)
		ld (newcentery),a
		ld e,a
		
        ld hl, b1x
		ld bc, newb1y
        ld a, 3
startflipblockloop:
        push af
		ld a, (hl)       ; load up b_x
		sub d             ; b_x = b_x - centerx
		neg               ; newb1y = -b_x
        add a,e
		ld (bc), a    ; store newb_y = -b_x
		inc hl
		dec bc
		ld a, (hl)
		sub e             ; b_y = b_y - centery
		add a, d
        ld (bc),a
		inc hl
		inc bc
		inc bc
		inc bc
        pop af
		dec a
		cp 0
		jr nz, startflipblockloop

        jp testtheblocks

putblockdown:

        ld bc,1            
        ld (downcounter),bc  

        ld a, 3              ; setting putting block down flag
        ld (lastaction),a

        ld c,3
        ld b,4
        ld hl, centery
		ld de, newcentery
downloop:		
		ld a, (hl)
        sub c
        ld (de),a
		inc hl
		inc hl
		inc de
		inc de
		djnz downloop

		ld a, (b1x)
        ld (newb1x),a
        ld a, (b2x)
        ld (newb2x),a
        ld a, (b3x)
        ld (newb3x),a
        ld a, (centerx)
        ld (newcenterx),a
		
		jp testtheblocks

goright:

        ld hl,(overrequests)
		inc hl
		ld de, 3
		call CP_HL_DE
		ld (overrequests), hl
		jp nz, keydloop
		ld hl,0
		ld (overrequests),hl

        ld c,3
		ld b,4
        ld hl, centerx
		ld de, newcenterx
gorightloop:
        ld a,(hl)
		add a,c
		ld (de),a
        inc hl
		inc hl
		inc de
		inc de
		djnz gorightloop
        
        ld a, (b1y)
        ld (newb1y),a
        ld a, (b2y)
        ld (newb2y),a
        ld a, (b3y)
        ld (newb3y),a
        ld a, (centery)
        ld (newcentery),a

        jr testtheblocks

goleft:

        ld hl,(overrequests)
		inc hl
		ld de, 3
		call CP_HL_DE
		ld (overrequests), hl
		jp nz, keydloop
		ld hl,0
		ld (overrequests),hl

        ld c,3
		ld b,4
        ld hl, centerx
		ld de, newcenterx
goleftloop:
        ld a,(hl)
		sub c
		ld (de),a
        inc hl
		inc hl
		inc de
		inc de
		djnz goleftloop

        ld a, (b1y) 
        ld (newb1y),a
        ld a, (b2y)
        ld (newb2y),a
        ld a, (b3y)
        ld (newb3y),a
        ld a, (centery)
        ld (newcentery),a
        
        jr testtheblocks        


testtheblocks:

        ld hl, newcenterx
        ld a, 5
testblockloop:
		ld b, (hl)
		inc hl
        ld c, (hl)
		inc hl
        push af
		call GetPixel
        jr nz, checkforline    
        pop af
		dec a
		cp 1
		jr nz, testblockloop

		jp makenewcoords


checkforline:
        
		pop af
        ld a, (lastaction)     
        cp 3                  ; Only if last action was down AND block was blocked do check
        jp nz, keydloop      ; else jump back to the beginning

        call erasefilledblock         ; erase the falling block and set it at its position
        call drawfilledblock
		
		ld hl, (thescore)
		inc hl
		ld (thescore), hl
 
        ; START dividing for getting y's for line array

        ld b, 0
		ld de,b3y
        ld hl,centery         		

topofdivloop:		
        push hl		
		ld a, (hl)            ; set line arrays        
        sub 3                  ; make good coords for psuedo div.
        ld c, 0
divloop:                    
        inc c                  ; to count how many times you sub 3
        sub 3                  
        jr nz, divloop
        ld hl,linearray        ; else load up line array
        add hl, bc             ; c is index off of linearray
        ld a, (hl)
        inc a                  ; make it so there's one more block here... 
        ld (hl),a             ; load line array back up
        pop hl
		call CP_HL_DE
		jr z, outofdivloop
		inc hl
		inc hl
        jr topofdivloop		

		;---------------------------------------------------------------------------------
outofdivloop:

        ld bc, 0
        ld (lastposition), bc   

gothru:                        ; Go thru and remove lines than need to be removed
        ld bc, (lastposition)
        inc bc  

        ld a,c                 ; if at top of line go grab another block
        cp 19
        jr z, addscore
        
        ld hl, linearray      
        add hl, bc           
        ld a, (hl)
        cp 10                  ; if there are ten blocks on the line get rid of it 
		jr z, getridofthisline ; and bring the rest down
        ld (lastposition),bc
        jr gothru

addscore:

        ld de, (linesremoved)
		ld hl, scoretable
		add hl, de
        ld a, (hl)
		ld c,a
		ld b,00h
		ld hl, (thescore)
		add hl,bc
		ld (thescore),hl

showscoreandjumpback:

      ld hl, (thescore)      ; update score
      ld a, $18
	  ld (atempvar + 1),a
	  ld a, $04
	  ld (atempvar),a
	  call D_ZM_M_STR

      ld hl, (thelines)     ;update line count
      ld a, $0A
	  ld (atempvar + 1),a
	  ld a, $04
	  ld (atempvar),a
	  call D_ZM_M_STR
	  
      jp grabablock


getridofthisline:
       
       ld de, (linesremoved)   ; there's one more line that got removed
	   inc de
	   ld (linesremoved), de

       ld de, (thelines)       ; update total line variable
       inc de
       ld (thelines), de
	   
       push bc

bringdownlinearray:

        inc hl                ; last hl points to linearray entry, go to next entry
        ld a, (hl)            ; save the value of the next entry...
        dec hl
        ld (hl), a            ; and put it in the orignal entry
        inc c                 ; c is current offset from line
        inc hl
        ld a, c
        cp 19
        jr nz, bringdownlinearray         

        pop bc

        ld hl,multtable   ; four lines to find y value of screen
        add hl,bc
        ld a, (hl)
        ld c,a          ; load up y into c

        ld b, 32        ; load up starting x into b
loopedfordeleteline:
        call eraseafilledblock
        ld a,b
		add a,3
		ld b,a
        cp 62                      ; are we at the end of the line?
        jr nz, loopedfordeleteline

nextline: 
        ld a, c      ; go to next line above the one your going to put block TO...
        add a, 3
        ld c, a
        ld b, 29     ; start at beginning of line
        cp 57
        jp z, gothru ; if at 57 you jump back
  
nextblockinline:
        ld a, b
        add a ,3
        cp 62
        jr z, nextline
        ld b, a
        call GetPixel
        jr nz, eraseanddraw
        jr nextblockinline

eraseanddraw:
        call eraseafilledblock
        ld a, c 
        sub 3
        ld c, a
        call drawafilledblock                          
        ld a, c
        add a, 3
        ld c, a
        jr nextblockinline

makenewcoords:

        call erasefilledblock      ; erase block

        ld a, (newcenterx)
        ld (centerx), a
        ld a, (newb1x)
        ld (b1x), a
        ld a, (newb2x)
        ld (b2x), a
        ld a, (newb3x)
        ld (b3x), a

        ld a, (newcentery)
        ld (centery), a
        ld a, (newb1y)
        ld (b1y), a
        ld a, (newb2y)
        ld (b2y), a
        ld a, (newb3y)
        ld (b3y), a

        ld a, (blastdownflag)
		cp 1
		jp z, putblockdown

        call drawblock      ; draw new block with new coords
       
        jp keydloop

; Begin Grafix / misc. routines
;------------------------------------------------------------------------------------------------

D_ZM_M_STR:
      LD B,5 
	  LD DE,$802C
d_zm_m_str_loop:
      CALL UNPACK_HL
      ADD A,$30
      LD (DE),A
      DEC DE
      djnz d_zm_m_str_loop
      LD A,0
      LD ($802D),A
      INC DE
      ex de,hl
      ld de, (atempvar)
	  ld ($8215), de
      ROM_CALL(D_ZM_STR)
      ret

drawblock:
        ld de, centerx + 8
		ld hl, centerx
drawblockloop:
	    ld b,(hl)
		inc hl
		ld c,(hl)
		call drawablock
		inc hl
		CALL CP_HL_DE
		jr nz, drawblockloop
	ret
        
drawfilledblock:
        ld de, centerx + 8
		ld hl, centerx
drawfilledblockloop:
	    ld b,(hl)
		inc hl
		ld c,(hl)
		call drawafilledblock
		inc hl
		CALL CP_HL_DE
		jr nz, drawfilledblockloop
	ret

erasefilledblock:
        ld de, centerx + 8
		ld hl, centerx
erasefilledblockloop:
	    ld b,(hl)
		inc hl
		ld c,(hl)
		call eraseafilledblock
		inc hl
		CALL CP_HL_DE
		jp nz, erasefilledblockloop
	ret

drawablock:
        
        dec b
        call Point_on
        dec c
        call Point_on
        inc b
        call Point_on
        inc b 
        call Point_on
        inc c
        call Point_on
        inc c
        call Point_on
        dec b
        call Point_on
        dec b
        call Point_on
        inc b
        dec c
        ret

drawafilledblock:

        call Point_on        
        dec b
        call Point_on
        dec c
        call Point_on
        inc b
        call Point_on
        inc b 
        call Point_on
        inc c
        call Point_on
        inc c
        call Point_on
        dec b
        call Point_on
        dec b
        call Point_on
        inc b
        dec c
        ret

eraseafilledblock:
        
        call Point_off        
        dec b
        call Point_off
        dec c
        call Point_off
        inc b
        call Point_off
        inc b 
        call Point_off
        inc c
        call Point_off
        inc c
        call Point_off
        dec b
        call Point_off
        dec b
        call Point_off
        inc b
        dec c
        ret


checkforhighscore:

        ld hl, (highscore)
		ld de, (thescore)
		call CP_HL_DE
        jr c, makenewhighscore
        ret

makenewhighscore:
       
      ld bc, (thescore)
      ld (highscore), bc

      ROM_CALL(CLEARLCD)

      ld de, $070F         ; congradulations!
      ld ($8215), de
      ld hl,congrats
      ROM_CALL(D_ZM_STR)

      ld de, $0F05         ; a new high score:
      ld ($8215), de
      ld hl,newhigh
      ROM_CALL(D_ZM_STR)
 
      ld hl, (highscore)     ; XXXXXX
	  ld a, $0F
	  ld (atempvar + 1),a
	  ld a, $45
	  ld (atempvar),a
	  call D_ZM_M_STR
	  
waitforkeypress:

      ld de, $161A
      ld ($8215), de
      ld hl,presssecond
      ROM_CALL(D_ZM_STR)

      call GET_KEY
      cp 36h                         
      jr nz, waitforkeypress

      ret
	  
waitalittle:
        ld de,2750
        ld hl,$0000
loopforwait2:
        inc hl
		call CP_HL_DE
		jr nz, loopforwait2
		
		ret
				


; Begin Stolen Routines from hacked graph.inc from Oshell -> Ash 2.0 developement kit
; ---------------------------------------------------------------------------------------------------------------
Point_on:
  push af                  ; Temporarily store af on the stack
  push bc                  ; Temporarily store bc on the stack
  push hl                  ; Temporarily store hl on the stack
  CALL FIND_PIXEL           ; Call FIND_PIXEL
  RESTORE_PIXEL            ; Restores the positioning of the controller
  ld b,a                   ; a -> b
  READ_PIXEL               ; Reads in the byte into a
  or b                     ; Turn "on" the proper pixel in a by ORing b
  RESTORE_PIXEL            ; Restores the positioning of the controller
  WRITE_PIXEL              ; Writes a out to the display controller
  pop hl                   ; Retrieve hl from the stack
  pop bc                   ; Retrieve bc from the stack
  pop af                   ; Retrieve af from the stack
  ret

Point_off:
  push af                  ; Temporarily store af on the stack
  push bc                  ; Temporarily store bc on the stack
  push hl                  ; Temporarily store hl on the stack
  CALL FIND_PIXEL          ; Call FIND_PIXEL
  RESTORE_PIXEL            ; Restores the positioning of the controller
  cpl                      ; xor $FF (reverses all bits in a)
  ld b,a                   ; a -> b
  READ_PIXEL               ; Reads in the byte into a
  and b                    ; Turns "off" the proper pixel in a by ANDing b
  RESTORE_PIXEL            ; Restores the positioning of the controller
  WRITE_PIXEL              ; Writes a out to the display controller
  pop hl                   ; Retrieve hl from the stack
  pop bc                   ; Retrieve bc from the stack
  pop af                   ; Retrieve af from the stack
  ret                      ; Return to caller

; Forgot what source I grabbed this from ...
;----------------------------------------------------------------------------------------------------------------

GetPixel:
	    
		push hl
		PUSH BC
        CALL FIND_PIXEL ; HL=byte offset in video buffer, A=2^(bit to change)
        LD B,A
        LD A,($8011)        ; Goto line
        CALL $07F3
        OUT ($10),A
        LD A,($800F)        ; Goto byte
        CALL $07F3
        OUT ($10),A
        CALL $07F3          ; Get byte
        IN A,($11)
        CALL $07F3
	    IN A,($11)
        AND B               ; Mask, so only one pixel left
        POP BC
		pop hl
       
		RET
;--------------------------------------------------------------------------

zetristitle: 
.db "Zetris", 0
zetrisver:
.db "v1.12", 0
by:
.db "By:", 0
cory:
.db "Cory",0
crooks:
.db "Crooks",0
email:
.db "badman@velocity.net",0
nextblocktext:
.db "Next:",0
linestext:
.db "Lines:",0
lineinit:
.db "00000",0
scoretext:
.db "Score:",0
highscoretext:
.db "High Score:",0
presssecond:
.db "Press 2nd...",0
congrats:
.db "Congradulations!",0
enterspeed:
.db "Please enter your speed",0
onetonine:
.db "from 1 to 9",0
newhigh:
.db "A new high score:",0
long:
.db 44,51,44,57,44,54,44,48
square:
.db 47,54,44,57,44,54,47,57
lone:
.db 44,54,44,57,44,51,47,51
ltwo:
.db 47,54,47,57,44,51,47,51
qone:
.db 47,54,44,51,44,54,47,57
qtwo:
.db 44,54,44,57,47,54,47,51
tb:
.db 44,54,44,57,44,51,47,54
highscore:
.db 0,0
speedlookup:
.db 255,128,96,64,48,32,16,8,4,2
multtable:
.db 3,6,9,12,15,18,21,24,27,30,33,36,39,42,45,47,50,53,56
scoretable:
.db 0,4,10,30,120
gamescreentextarray:
.dw 0343h,zetristitle,0A44h,zetrisver,2004h,nextblocktext,2748h,by,2E44h,cory,3543h,crooks,0304h,linestext,0A04h,lineinit,1104h,scoretext,1804h,lineinit
loadblocklookuptable:
.dw square,long,lone,ltwo,qone,qtwo,tb,tb,tb
zetris_xpos_array:
.db 12,15,18,24,27,30,36,39,42,48,51,60,63,66,75,78,0,
.db 18,24,39,48,54,63,72,0,
.db	15,24,27,39,48,51,63,75,0,
.db	12,24,39,48,54,63,78,0,
.db	12,15,18,24,27,30,39,48,54,60,63,66,72,75,1
.end
.end
